
#property copyright "Copyright  2007 lambic" // Fisher lambic
#property link      ""

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 LightGreen
#property indicator_color2 Coral
#property indicator_color3 Black
#property indicator_color4 Lime
#property indicator_color5 Red
#property indicator_color6 SteelBlue
#property indicator_color7 Orange

double G_ibuf_76[];
double G_ibuf_80[];
double G_ibuf_84[];
double G_ibuf_88[];
double G_ibuf_92[];
double G_ibuf_96[];
double G_ibuf_100[];
extern int period = 100;
extern double Threshold = 0.1;
extern bool UseSound=true;
extern string SoundFile="Alert.wav";
extern int _ = 1;
bool SoundBuy  = False;
bool SoundSell = False;
double Gd_116 = 0.5;
int Gi_124 = 1;
int Gi_128 = 1;
int Gi_132 = 1;
int Gi_136 = 0;
bool Gi_140 = FALSE;
bool Gi_144 = FALSE;
extern int MA1period = 9;
extern int MA2period = 45;
string Gs_unused_156 = "SMA- 0, EMA - 1, SMMA - 2, LWMA- 3";
string Gs_unused_164 = "John Hyden settings TypeMA1=0, TypeMA2=3";
int G_ma_method_172 = MODE_SMA;
int G_ma_method_176 = MODE_LWMA;
double Gd_180 = 0.0;
double Gd_188 = 0.0;
double Gd_unused_196 = 0.0;
double Gd_204 = 0.0;
double Gd_212 = 0.0;
double Gd_220 = 0.0;
int Gi_unused_228 = 0;
int Gi_unused_232 = 0;

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 1, LightGreen);
   SetIndexBuffer(0, G_ibuf_76);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 1, Red);
   SetIndexBuffer(1, G_ibuf_80);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexLabel(2, "line");
   SetIndexBuffer(2, G_ibuf_84);
   SetIndexStyle(3, DRAW_LINE);
   SetIndexLabel(3, "MA1 " + MA1period);
   SetIndexStyle(4, DRAW_LINE);
   SetIndexLabel(4, "MA2 " + MA2period);
   SetIndexBuffer(3, G_ibuf_88);
   SetIndexBuffer(4, G_ibuf_92);
   SetIndexStyle(5, DRAW_HISTOGRAM, STYLE_SOLID, 2, SteelBlue);
   SetIndexBuffer(5, G_ibuf_96);
   SetIndexStyle(6, DRAW_HISTOGRAM, STYLE_SOLID, 2, Orange);
   SetIndexBuffer(6, G_ibuf_100);
   return (0);
}

// 52D46093050F38C27267BCE42543EF60
int deinit() {
   for (int count_0 = 0; count_0 < Bars; count_0++) {
      ObjectDelete("SELL SIGNAL: " + DoubleToStr(count_0, 0));
      ObjectDelete("BUY SIGNAL: " + DoubleToStr(count_0, 0));
      ObjectDelete("EXIT: " + DoubleToStr(count_0, 0));
   }
   return (0);
}

// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   double price_12;
   double Ld_unused_20;
   int Li_0 = IndicatorCounted();
   double low_28 = 0;
   double high_36 = 0;
   if (Li_0 > 0) Li_0--;
   int Li_8 = Bars - Li_0;
   if (Gi_140) Li_8 = 100;
   for (int Li_4 = 0; Li_4 < Li_8; Li_4++) {
      high_36 = High[iHighest(NULL, 0, MODE_HIGH, period, Li_4)];
      low_28 = Low[iLowest(NULL, 0, MODE_LOW, period, Li_4)];
      switch (Gi_136) {
      case 1:
         price_12 = Open[Li_4];
         break;
      case 2:
         price_12 = Close[Li_4];
         break;
      case 3:
         price_12 = High[Li_4];
         break;
      case 4:
         price_12 = Low[Li_4];
         break;
      case 5:
         price_12 = (High[Li_4] + Low[Li_4] + Close[Li_4]) / 3.0;
         break;
      case 6:
         price_12 = (Open[Li_4] + High[Li_4] + Low[Li_4] + Close[Li_4]) / 4.0;
         break;
      case 7:
         price_12 = (Open[Li_4] + Close[Li_4]) / 2.0;
         break;
      default:
         price_12 = (High[Li_4] + Low[Li_4]) / 2.0;
      }
      Gd_180 = 0.66 * ((price_12 - low_28) / (high_36 - low_28) - 0.5) + 0.67 * Gd_188;
      Gd_180 = MathMin(MathMax(Gd_180, -0.999), 0.999);
      Gd_204 = Gd_116 * MathLog((Gd_180 + 1.0) / (1 - Gd_180)) + Gd_212 / 2.0;
      G_ibuf_76[Li_4] = 0;
      G_ibuf_80[Li_4] = 0;
      G_ibuf_96[Li_4] = 0;
      G_ibuf_100[Li_4] = 0;
      if (Gd_204 < 0.0 && Gd_212 > 0.0) {
         if (Gi_144) {
            ObjectCreate("EXIT: " + DoubleToStr(Li_4, 0), OBJ_TEXT, 0, Time[Li_4], price_12);
            ObjectSetText("EXIT: " + DoubleToStr(Li_4, 0), "EXIT AT " + DoubleToStr(price_12, 4), 7, "Arial", White);
         }
         Gi_unused_228 = 0;
      }
      if (Gd_204 > 0.0 && Gd_212 < 0.0) {
         if (Gi_144) {
            ObjectCreate("EXIT: " + DoubleToStr(Li_4, 0), OBJ_TEXT, 0, Time[Li_4], price_12);
            ObjectSetText("EXIT: " + DoubleToStr(Li_4, 0), "EXIT AT " + DoubleToStr(price_12, 4), 7, "Arial", White);
         }
         Gi_unused_232 = 0;
      }
      if (Gd_204 >= 0.0) {
         if (Gi_132 == 1 && Gd_204 > Threshold && Gd_212 > Threshold) G_ibuf_96[Li_4] = 2;
         else {
            if (Gi_132 == 1 && Gd_204 > 0.0 && Gi_128 == 1) G_ibuf_76[Li_4] = 1;
            else G_ibuf_76[Li_4] = Gd_204;
         }
         G_ibuf_84[Li_4] = Gd_204;
      } else {
         if (Gi_132 == 1 && Gd_204 < (-Threshold) && Gd_212 < (-Threshold)) G_ibuf_100[Li_4] = 2;
         else {
            if (Gi_132 == 1 && Gd_204 < 0.0 && Gi_128 == 1) G_ibuf_80[Li_4] = 1;
            else G_ibuf_80[Li_4] = Gd_204;
         }
         G_ibuf_84[Li_4] = Gd_204;
      }
      Ld_unused_20 = Li_4;
      if (Gd_204 < (-Threshold) && Gd_204 > Gd_212 && Gd_212 <= Gd_220) {
         if (Gi_144) {
            ObjectCreate("SELL SIGNAL: " + DoubleToStr(Li_4, 0), OBJ_TEXT, 0, Time[Li_4], price_12);
            ObjectSetText("SELL SIGNAL: " + DoubleToStr(Li_4, 0), "SELL AT " + DoubleToStr(price_12, 4), 7, "Arial", Red);
         }
         Gi_unused_232 = 1;
      }
      if (Gd_204 > Threshold && Gd_204 < Gd_212 && Gd_212 >= Gd_220) {
         if (Gi_144) {
            ObjectCreate("BUY SIGNAL: " + DoubleToStr(Li_4, 0), OBJ_TEXT, 0, Time[Li_4], price_12);
            ObjectSetText("BUY SIGNAL: " + DoubleToStr(Li_4, 0), "BUY AT " + DoubleToStr(price_12, 4), 7, "Arial", Lime);
         }
         Gi_unused_228 = 1;
      }
      Gd_188 = Gd_180;
      Gd_220 = Gd_212;
      Gd_212 = Gd_204;
   }
   for (Li_4 = 0; Li_4 < Li_8; Li_4++)
      if (Gi_124 == 1) G_ibuf_88[Li_4] = iMAOnArray(G_ibuf_84, Bars, MA1period, 0, G_ma_method_172, Li_4);
   for (Li_4 = 0; Li_4 < Li_8; Li_4++)
      if (Gi_124 == 1) G_ibuf_92[Li_4] = iMAOnArray(G_ibuf_88, Bars, MA2period, 0, G_ma_method_176, Li_4);
  if (G_ibuf_96[_] != EMPTY_VALUE && G_ibuf_96[_] != 0 && SoundBuy)
         {
         SoundBuy = False;
            if (UseSound) PlaySound (SoundFile);
               Alert(" Fisher lambic (", Symbol(), ", ", Period(), ")  -  BUY!!!"); 
         } 
      if (!SoundBuy && (G_ibuf_96[_] == EMPTY_VALUE || G_ibuf_96[_] == 0)) SoundBuy = True;  
            
  
      if (G_ibuf_100[_] != EMPTY_VALUE && G_ibuf_100[_] != 0 && SoundSell)
         {
         SoundSell = False;
            if (UseSound) PlaySound (SoundFile);
             Alert(" Fisher lambic (", Symbol(), ", ", Period(), ")  -  SELL!!!"); 
         } 
      if (!SoundSell && (G_ibuf_100[_] == EMPTY_VALUE || G_ibuf_100[_] == 0)) SoundSell = True;  
   return (0);
}